# **JSONrisk components**  

## Input Data Management

 - Manage financial instruments, positions and portfolios in the [Portfolio applet ](/docs/Portfolios.md)
 - Manage market data and other parameters in the [Parameters applet ](/docs/Parameters.md)
 - Manage scenarios in the [Scenarios applet ](/docs/Scenarios.md)
 - Manage time series in the [Time Series applet ](/docs/Time_Series.md)

## Perform Calculations

 - Start ad-hoc calculations in your browser with the [Pricing applet ](/docs/Pricing.md)
 - Plan and start calculations and other tasks on the server backend with the [Batch applet ](/docs/Batch.md)

## Analyze Results

 - Analyze single-instrument results with the [Analysis applet ](/docs/Analysis.md)
 - Analyze results on portfolio level with the [Reports applet ](/docs/Reports.md)

## Maintenance

 - Manage users and reset your password [User Management ](/docs/User_Management.md)
 - How to implement advanced customizations with [Modules ](/docs/Modules.md)

## JSONrisk library docs

 - The [Instruments guide](https://www.jsonrisk.de/01_Documentation/01_Instruments.html) summarizes supported instruments and features
 - The [Fields guide](https://www.jsonrisk.de/01_Documentation/02_Fields.html) contains a complete list of JSON fields for describing instrument terms and conditions
 - The [Data types guide](https://www.jsonrisk.de/01_Documentation/03_Data_types.html) explains the data types used in the JSON fields
 - The [Parameters guide](https://www.jsonrisk.de/01_Documentation/02_Parameters.html) explains how to represent parameters for valuation, e.g., yield curves and surfaces.
 - The [Schedule generation guide](https://www.jsonrisk.de/01_Documentation/05_Schedule_generation.html) explains how JSON risk generates schedules for interest rate instruments.
